create_multi_id_with_suffix=function(data_DT_1col,idcol){
if ("x_Suffix" %in% idcol) {
k_pom=(nchar(data_DT_1col$x_Suffix)==0)
data_DT_1col[ k_pom , data_multi_id_all:=apply(  data_DT_1col[ k_pom , idcol[-which("x_Suffix"==idcol)], with=FALSE] ,1, paste, collapse="_") ]
k_pom=(nchar(data_DT_1col$x_Suffix)>0)
data_DT_1col[ k_pom , data_multi_id_all:=apply(  data_DT_1col[ k_pom , idcol, with=FALSE] ,1, paste, collapse="_") ]
data_multi_id_all=data_DT_1col$data_multi_id_all
data_DT_1col[,data_multi_id_all:=NULL ]}else{
data_multi_id_all=apply(  data_DT_1col[ , idcol, with=FALSE] ,1, paste, collapse="_")}
return(data_multi_id_all)}
Read_file_dbf_csv = function(file_info="" , k_delete=FALSE, k_check_info_file=FALSE, k_check_data_file=FALSE, k_save_adjusted=FALSE  , k_DataTable=TRUE ,
k_the_same_region,k_CSV,k_use_marked_deleted,print_output=TRUE,missval=-999,
k_remove_duplicate_col_names=TRUE,k_check_ngb_info=FALSE ){
data_info=NA
if (file.exists(file_info)){
if (tolower(file_extension(file_info))=="dbf") {
data_info=my__read_dbf(file_info,remove.x=T,delete=k_delete,read_MFD=T,k_del_NA=FALSE,k_convert_codepage=T,print_output=print_output )
if (any( c("MFD","MFD_","DEL_","_DEL") %in% names(data_info))) k_use_marked_deleted=TRUE
ii_d=match("X.",names(data_info))
if (!all(is.na(ii_d))) data_info=data_info[,-(ii_d:length(names(data_info)) )]
ii_d=match("X_NullFlags",names(data_info))
if (!all(is.na(ii_d))) data_info=data_info[,-(ii_d:length(names(data_info)) )]}else{
data_info=fread(file_info)
if (k_CSV==FALSE){
eval.parent(substitute(k_CSV<-TRUE ))
if (print_output==TRUE) print_my("Read_file_dbf_csv: Parameter for using CSV (k_CSV) changed to TRUE",k_warning=TRUE)
if (print_output==TRUE) print_my("Outputs will be saved as CSV files", k_add_print_=TRUE)}}
names(data_info)=toupper(names(data_info))
if (k_check_ngb_info==TRUE){
if ("ALT_1" %in% names(data_info)) {
if (typeof(data_info$ALT_1)=="logical") {
if (print_output==TRUE) print_my(basename(file_info),": ","ALT_1 converted to Numeric data type",k_warning=FALSE)
if (is.data.table(data_info)) data_info[,ALT_1:=NULL]
data_info$ALT_1=0
data_info$ALT_1=NA}}
if ("ALT_2" %in% names(data_info)) {
if (typeof(data_info$ALT_2)=="logical") {
if (print_output==TRUE) print_my(basename(file_info),": ","ALT_2 converted to Numeric data type",k_warning=FALSE)
if (is.data.table(data_info)) data_info[,ALT_2:=NULL]
data_info$ALT_2=0
data_info$ALT_2=NA}}}
if (k_check_info_file==TRUE){
ss_pom=unique(substr(names(data_info),1,1))
if (length(ss_pom)==1) if (ss_pom=="V") {
setnames(data_info, names(data_info)[1:5] , c("ID","NAME","REGION","LATITUDE","LONGITUDE") )
DMS <- sapply(strsplit(data_info$LATITUDE, paste0('[', ":", ":", NA, ']')), as.numeric)
data_info$LATITUDE <- abs(DMS[1,]) + DMS[2,]/60 + DMS[3,]/3600
DMS <- sapply(strsplit(data_info$LONGITUDE, paste0('[', ":", ":", NA, ']')), as.numeric)
data_info$LONGITUDE <- abs(DMS[1,]) + DMS[2,]/60 + DMS[3,]/3600
if (is.numeric(data_info$ID)){
data_info[ , ID := paste0("P",   formatC( ID , width=4, flag="0")) ]}
data_info=data_frame_remove_NA_cols(data_info)
if (print_output==TRUE)
print_my("Info_file converted from CSV INDECIS format ...", k_add_print_=TRUE)}
if (toupper("sta_id") %in% names(data_info)) names(data_info)[which(toupper("sta_id")==names(data_info))]="ID"
if (toupper("lat")    %in% names(data_info)) names(data_info)[which(toupper("lat")   ==names(data_info))]="LATITUDE"
if (toupper("lon")    %in% names(data_info)) names(data_info)[which(toupper("lon")   ==names(data_info))]="LONGITUDE"
if (toupper("elev")   %in% names(data_info)) names(data_info)[which(toupper("elev")  ==names(data_info))]="ALTITUDE"
if (toupper("region") %in% names(data_info)) names(data_info)[which(toupper("region")==names(data_info))]="REGION"
if (toupper("start")  %in% names(data_info)) names(data_info)[which(toupper("start") ==names(data_info))]="BEGIN"
if (toupper("stop")   %in% names(data_info)) names(data_info)[which(toupper("stop")  ==names(data_info))]="END"
if ("ID" %in% names(data_info)) if (!is.character(data_info$ID)) {
if (print_output==TRUE) print_my(basename(file_info),": ","ID converted to Character data type",k_warning=FALSE)
data_info$ID=as.character(data_info$ID)}
if ("LATITUDE" %in% names(data_info))  {
if (!is.numeric(data_info$LATITUDE)){
if (print_output==TRUE) print_my(basename(file_info),": ","LATITUDE converted to Numeric data type",k_warning=FALSE)
if (all(is.na(as.numeric(data_info$LATITUDE)))) data_info$LATITUDE=gsub(",",".",data_info$LATITUDE,fixed=TRUE)
data_info$LATITUDE=as.numeric(data_info$LATITUDE)}
data_info[[ "LATITUDE" ]][ data_info[[ "LATITUDE" ]]==missval | (is.na(data_info[[ "LATITUDE" ]])) ]=NA}
if ("LONGITUDE" %in% names(data_info)) {
if (!is.numeric(data_info$LONGITUDE)){
if (print_output==TRUE) print_my(basename(file_info),": ","LONGITUDE converted to Numeric data type",k_warning=FALSE)
if (all(is.na(as.numeric(data_info$LONGITUDE)))) data_info$LONGITUDE=gsub(",",".",data_info$LONGITUDE,fixed=TRUE)
data_info$LONGITUDE=as.numeric(data_info$LONGITUDE)}
data_info[[ "LONGITUDE" ]][ data_info[[ "LONGITUDE" ]]==missval | (is.na(data_info[[ "LONGITUDE" ]])) ]=NA}
if ("ALTITUDE" %in% names(data_info)) {
if (!is.numeric(data_info$ALTITUDE)){
if (all(is.na(as.numeric(data_info$ALTITUDE)))) data_info$ALTITUDE=gsub(",",".",data_info$ALTITUDE,fixed=TRUE)
if (print_output==TRUE) print_my(basename(file_info),": ","ALTITUDE converted to Numeric data type",k_warning=FALSE)
data_info$ALTITUDE=as.numeric(data_info$ALTITUDE)}
data_info[[ "ALTITUDE" ]][ data_info[[ "ALTITUDE" ]]==missval | (is.na(data_info[[ "ALTITUDE" ]])) ]=NA}
if ("REGION" %in% names(data_info)) if (!is.character(data_info$REGION)) {
if (print_output==TRUE) print_my(basename(file_info),": ","REGION converted to Character data type",k_warning=FALSE)
data_info$REGION=as.character(data_info$REGION)}
if ("BEGIN" %in% names(data_info)) {
x=data_info$BEGIN
if ((is.character(x))&(min(nchar(x))>=10)) k_pom=FALSE else k_pom=TRUE
if (k_pom)
if (!all(is.na(as.numeric(data_info$BEGIN)))){
if (min(as.numeric(data_info$BEGIN),na.rm=TRUE)>16000000 ){
if (print_output==TRUE) print_my(basename(file_info),": ","BEGIN converted to Date data type",k_warning=FALSE)
data_info$BEGIN=as.Date( as.character(data_info$BEGIN), format="%Y%m%d")}}
if (is.character(data_info$BEGIN)){
if (!all(is.na(as.Date(data_info$BEGIN)))){
if (print_output==TRUE) print_my(basename(file_info),": ","BEGIN converted to Date data type",k_warning=FALSE)
data_info$BEGIN=(as.Date(data_info$BEGIN) )}}}
if ("END" %in% names(data_info)) {
x=data_info$END
if ((is.character(x))&(min(nchar(x))>=10)) k_pom=FALSE else k_pom=TRUE
if (k_pom)
if (!all(is.na(as.numeric(data_info$END)))){
if (min(as.numeric(data_info$END),na.rm=TRUE)>19000000 ){
if (print_output==TRUE) print_my(basename(file_info),": ","END converted to Date data type",k_warning=FALSE)
data_info$END=as.Date( as.character(data_info$END), format="%Y%m%d")}}
if (is.character(data_info$END)){
if (!all(is.na(as.Date(data_info$END)))){
if (print_output==TRUE) print_my(basename(file_info),": ","END converted to Date data type",k_warning=FALSE)
data_info$END=(as.Date(data_info$END) )}}}}
if (k_check_data_file==TRUE){
if (names(data_info)[1]=="DATES") {
names_measure=(names(data_info)[-1] )
ss_pom=unique(substr(names_measure,1,1))
if (length(ss_pom)==1) if (ss_pom=="P") {
data_info$DATES=as.Date(data_info$DATES )
data_info[ , YEAR:=as.numeric( format(DATES, "%Y") ) ]
data_info[ , MONTH:=as.numeric( format(DATES, "%m") ) ]
data_info[ , DAY:=as.numeric( format(DATES, "%d") ) ]
data_info[,DATES:=NULL ]
data_DT_1col=melt(data_info,  measure.vars=names_measure, variable.name="ID", value.name="VALUE2")
data_info=Change_Column_order(data_DT_1col, col_names=c("ID","YEAR","MONTH","DAY","VALUE2") , order=1 )
if (print_output==TRUE)
print_my("Data file converted from CSV INDECIS format to one column ...", k_add_print_=TRUE)}}
if ("STAID" %in% names(data_info)) names(data_info)[which("STAID"==names(data_info))[1]]="ID"
if ("EG_GH_ID" %in% names(data_info)) names(data_info)[which("EG_GH_ID"==names(data_info))[1]]="ID"
if ("YYYY" %in% names(data_info)) names(data_info)[which("YYYY"==names(data_info))[1]]="YEAR"
if ("MM" %in% names(data_info)) names(data_info)[which("MM"==names(data_info))[1]]="MONTH"
if ("DD" %in% names(data_info)) names(data_info)[which("DD"==names(data_info))[1]]="DAY"
if ("HH:MM" %in% names(data_info)) names(data_info)[which("HH:MM"==names(data_info))]="TIME"
if ("HH.MM" %in% names(data_info)) names(data_info)[which("HH.MM"==names(data_info))]="TIME"
if ( ("DD.1" %in% names(data_info)) &
(!("DD" %in% names(data_info))) ) names(data_info)[which("DD.1"==names(data_info))[1]]="DD"
if ("ID" %in% names(data_info)) if (!is.character(data_info$ID)) data_info$ID=as.character(data_info$ID)
if ("YEAR" %in% names(data_info)) if (!is.numeric(data_info$YEAR)) data_info$YEAR=as.numeric(data_info$YEAR)
if ("MONTH" %in% names(data_info)) if (!is.numeric(data_info$MONTH)) data_info$MONTH=as.numeric(data_info$MONTH)
if ("DAY" %in% names(data_info)) if (!is.numeric(data_info$DAY)) data_info$DAY=as.numeric(data_info$DAY)
if ("TIME" %in% names(data_info)) if (!is.character(data_info$TIME)) data_info$TIME=as.character(data_info$TIME)}
if (k_remove_duplicate_col_names==TRUE){
ss_pom=names(data_info)
if (length(unique(ss_pom))!=length(ss_pom)){
if (print_output==TRUE){
print_my("Read_file_dbf_csv: Columns removed (doubled): ", k_add_print_=FALSE)
print((names(data_info))[duplicated(ss_pom)])}
ss_pom=(names(data_info))[ !duplicated(ss_pom) ]
data_info=data_info[,ss_pom,with=FALSE]}}
if (k_DataTable==TRUE){
data_info=data.table(data_info)}
if ((k_check_info_file==TRUE) & (k_DataTable==TRUE) ){
if (print_output==TRUE){
print("")
print("Read_file_dbf_csv: Preparing data info file (BEGIN and END columns)")}
if (!all(c("BEGIN","END") %in% names(data_info))) {
if (all(c("BEGIN_DATE","END_DATE") %in% names(data_info))) {
setnames(data_info, c("BEGIN_DATE","END_DATE") , c("BEGIN","END") )
if (print_output==TRUE) print_my(c("BEGIN_DATE","END_DATE")," renamed to ",c("BEGIN","END"))}}
if (!all(c("REGION") %in% names(data_info))) {
if (all(c("ELEMENT") %in% names(data_info))) {
setnames(data_info, c("ELEMENT") , c("REGION") )
if (print_output==TRUE) print_my(c("ELEMENT")," renamed to ",c("REGION"))}}
if (!all(c("REGION") %in% names(data_info))) {
if (print_output==TRUE) print_my("Read_file_dbf_csv: Parameter for the same region (k_the_same_region) changed to FALSE",k_warning=TRUE)
eval.parent(substitute(k_the_same_region <- F ))}
if (all(c("BEGIN","END") %in% names(data_info))) {
if (class(data_info$END)=="Date") {
data_info$END[ format(data_info$END, "%Y") > 3000 ] = as.Date(Sys.time(), format='%m/%d/%Y')
data_info$END[ is.na(data_info$END) ] = as.Date(Sys.time(), format='%m/%d/%Y')}
if (class(data_info$END)=="Numeric") {
data_info$END[ data_info$END > 3000 ] =  format(Sys.time(), "%Y")
data_info$END[ is.na(data_info$END) ] =  format(Sys.time(), "%Y")}
ii_pom=sum(is.na(data_info$BEGIN))
if (ii_pom>0){
date_min=min(data_info$BEGIN,na.rm=TRUE)
if (print_output==TRUE) print_my("Read_file_dbf_csv: Some BEGIN dates are empty: ",ii_pom,", it will be replaced with minimum date found: ",date_min, k_warning=TRUE)
data_info$BEGIN[ is.na(data_info$BEGIN) ]=date_min}}}
if (k_save_adjusted==TRUE){
if (tolower(file_extension(file_info))=="dbf") {}else{
file_info=filename2(file_info, extension="dbf")
k_pom=rep(0,nrow(data_info))
if (toupper("MARK_NGB") %in% names(data_info)) {
k_pom=as.numeric(data_info$MARK_NGB)
if (print_output==TRUE) print_my("Read_file_dbf_csv: Stations marked in Mark_ngb column with 1 will be used only as neighbours", k_add_print_=TRUE)}
my__write_dbf(data_info,file_info,print_output=FALSE,mfd=k_pom )
if (print_output==TRUE) print_my("Input Info file saved as .dbf file (Read_file_dbf_csv): ",file_info, k_add_print_=TRUE)}}
if ( !("MFD" %in% names(data_info)) & (toupper("MARK_NGB") %in% names(data_info)) ) {
names(data_info)[which("MARK_NGB"==names(data_info))]="MFD"
if (print_output==TRUE) print_my("Read_file_dbf_csv: Parameter for using rows marked as deleted (k_use_marked_deleted) changed to TRUE",k_warning=TRUE)
eval.parent(substitute(k_use_marked_deleted <- TRUE ))}}else{
if (print_output==TRUE) print_my("Read_file_dbf_csv: input data file not found: ",file_info, k_warning=TRUE)
file_info=NA}
return(data_info)}
Create_info_file_insitu = function(data_DT_1col , ss_group_idcol , ss_separator="_" , k_ID_multi=TRUE ) {
if (dim(data_DT_1col)[1]==0) return(data.table(ID=NA,REGION=NA,BEG_year=NA,END_year=NA,BEGIN=NA,END=NA,LENGTH=NA) )
if (!("VALUE2" %in% names(data_DT_1col))) stop("VALUE2 column is not present in data_DT_1col variable (function Create_info_file_insitu)")
ss_group_idcol=c(ss_group_idcol,"x_Suffix")
ss_group_idcol=unique(ss_group_idcol)
ss_group_idcol=ss_group_idcol[ ss_group_idcol %in% names(data_DT_1col) ]
k_add_dt=FALSE
if (!("dt" %in% names(data_DT_1col))) {
if (all( c("YEAR","MONTH","DAY") %in% names(data_DT_1col))) {
k_add_dt=TRUE
data_DT_1col[ , dt:=as.Date( paste(YEAR,MONTH,DAY, sep="-") , format="%Y-%m-%d"  ) ]}}
if ("dt" %in% names(data_DT_1col) ) {
data_info_DT2=data_DT_1col[,list(BEG_year=min(as.numeric(YEAR),na.rm=TRUE),END_year=max(as.numeric(YEAR),na.rm=TRUE),LEN_Y=NA,BEGIN=min(dt,na.rm=TRUE),END=max(dt,na.rm=TRUE ),LENGTH=NA,CNT=sum(VALUE2*0+1,na.rm=TRUE),MISS_CNT=sum((VALUE2==missval)|is.na(VALUE2)),MISS_MAX=max(Get_values_changes(x=is.na(VALUE2),limit_value=1,n_min_consecutive_vals=1 ),na.rm=TRUE) ),by=ss_group_idcol ]
data_info_DT2[,LEN_Y:=END_year-BEG_year+1 ]
data_info_DT2[,LENGTH:=as.numeric(END-BEGIN+1) ]
if (all(data_info_DT2$MISS_CNT==0)) if (any(data_info_DT2$CNT<data_info_DT2$LENGTH)){
data_info_DT2[,MISS_CNT:=LENGTH-CNT ]
data_info_DT2[,MISS_MAX:=NA ]
if (any(data_DT_1col$diff_date0>0)){
data_info_DT2[,MISS_MAX:=NULL ]
data_info_DT2b=data_DT_1col[,list(MISS_MAX=max(as.numeric(diff_date0),na.rm=TRUE),MISS_CNT_=sum(diff_date0,na.rm=TRUE) ),by=ss_group_idcol ]
setkeyv(data_info_DT2,ss_group_idcol)
setkeyv(data_info_DT2b,ss_group_idcol)
data_info_DT2=data_info_DT2[data_info_DT2b]}}}else{
if ("YEAR" %in% names(data_DT_1col) ) {
data_info_DT2=data_DT_1col[,list(BEGIN=min(as.numeric(YEAR),na.rm=TRUE),END=max(as.numeric(YEAR),na.rm=TRUE),CNT=sum(VALUE2*0+1,na.rm=TRUE),MISS_CNT=sum((VALUE2==missval)|is.na(VALUE2)),MISS_MAX=max(Get_values_changes(x=is.na(VALUE2),limit_value=1,n_min_consecutive_vals=1 ),na.rm=TRUE) ),by=ss_group_idcol ]
data_info_DT2[,LENGTH:=END-BEGIN+1 ]}else{
data_info_DT2=data_DT_1col[,list(CNT=sum(VALUE2*0+1,na.rm=TRUE),MISS_CNT=sum((VALUE2==missval)|is.na(VALUE2)),MISS_MAX=max(Get_values_changes(x=is.na(VALUE2),limit_value=1,n_min_consecutive_vals=1 ),na.rm=TRUE) ),by=ss_group_idcol ]}}
if ("LENGTH" %in% names(data_info_DT2)) data_info_DT2[ , PRC_MISS := round( 100*MISS_CNT/as.numeric(LENGTH) , 1) ]
if ((length(ss_group_idcol)>1)&(k_ID_multi==TRUE)){
data_info_DT2[,ID_ORIG:=data_info_DT2[,ss_group_idcol[1],with=FALSE ] ]
ii_pom=length(ss_group_idcol) - ifelse("x_Suffix" %in% names(data_DT_1col),1,0)
if (ii_pom>=2){
ii_pom=2:(ii_pom )
data_info_DT2[,REGION:=apply(data_info_DT2[,ii_pom,with=FALSE],1,paste,collapse=ss_separator) ]}else{
data_info_DT2[ , REGION:=  "" ]}
if ("x_Suffix" %in% names(data_info_DT2)) {
k_pom=(!(is.na(data_info_DT2$x_Suffix)))&(!(nchar(data_info_DT2$x_Suffix)==0))
data_info_DT2[ k_pom,ID:=apply(data_info_DT2[ k_pom,1:(length(ss_group_idcol)),with=FALSE],1,paste,collapse=ss_separator) ]
data_info_DT2[ (!k_pom) & nchar(REGION)>0,ID:=paste(ID_ORIG,REGION,sep=ss_separator) ]
data_info_DT2[ (!k_pom) & nchar(REGION)==0,ID:=paste(ID_ORIG,sep=ss_separator) ]
data_info_DT2[ is.na(x_Suffix) , x_Suffix:="" ]}else{
data_info_DT2[ nchar(REGION)>0,ID:=paste(ID_ORIG,REGION,sep=ss_separator) ]
data_info_DT2[ nchar(REGION)==0,ID:=paste(ID_ORIG,sep=ss_separator) ]}}
return(data_info_DT2 )}
insert_rows_data = function(data_DT_1col, ss_group_idcol , hranice_dej_missval=0  , k_leave_aux_cols=FALSE , ss_separator="-" , k_print=TRUE ) {
if (dim(data_DT_1col)[1]==0) return(data_DT_1col)
ss_group_idcol=ss_group_idcol[ ss_group_idcol %in% names(data_DT_1col) ]
ss_group_idcol=unique(ss_group_idcol)
ii_pom=match(toupper("x_Suffix"),ss_group_idcol)
if (!is.na(ii_pom)) ss_group_idcol[ii_pom]="x_Suffix"
ii_pom=match("x_Suffix",ss_group_idcol)
if (!is.na(ii_pom)) ss_group_idcol=ss_group_idcol[-ii_pom]
col_id=ss_group_idcol
data_DT_1col[,x_Suffix:=""]
ID_ORIG=data_DT_1col[ , c(col_id,"x_Suffix") , with=FALSE]
k_daily=TRUE
if ("DAY" %in% names(data_DT_1col)) {
data_DT_1col=data_DT_1col[ !((DAY==31) & (MONTH %in% c(2,4,6,9,11)) & (is.na(VALUE2)) ),]
data_DT_1col=data_DT_1col[ !((DAY==30) & (MONTH %in% c(2)) & (is.na(VALUE2)) ),]
data_DT_1col=data_DT_1col[ !((DAY==29) & (MONTH %in% c(2)) & (!(is.leapyear(YEAR))) & (is.na(VALUE2)) ),]}else{
k_daily=FALSE
data_DT_1col[,DAY:=1 ]}
ss_pom=c(ss_group_idcol, "x_Suffix", c("YEAR","MONTH","DAY" ,"TIME","HOUR","MINUTE"))
ss_pom=ss_pom[ ss_pom %in% names(data_DT_1col) ]
ss_columns=ss_pom
setkeyv(data_DT_1col,ss_pom )
data_DT_1col[ , dt:=as.Date( paste(YEAR,MONTH,DAY, sep="-") , format="%Y-%m-%d"  ) ]
data_DT_1col[,diff_date:=my_diff(dt,my_lag=1,start_NA=TRUE),by=ss_group_idcol ]
val_unique_year=(na.omit(data_DT_1col$diff_date))
if (any(val_unique_year>1)){
k_pom=which(data_DT_1col$diff_date>1 )
if (k_print){
print("")
print_my("   ", "", ": there are time gaps in data, ",", gaps lenght: ", val_unique_year[val_unique_year>1],", positions (rows): ",k_pom, k_warning=TRUE)}
k_pom=c((k_pom-1),k_pom )
k_pom=sort(k_pom)
if (k_print){
print("Table, with End data and Begin data (second row, after the gap): ")
print(data_DT_1col[ k_pom,])
print("")}}
n_fill_number=as.numeric(data_DT_1col$diff_date)
n_rows_insert=which(data_DT_1col$diff_date>1 )
if (k_daily==FALSE){
n_rows_insert=which(data_DT_1col$diff_date>31 )}
data_DT_1col[,row_:=1:nrow(data_DT_1col) ]
data_DT_1col[,group_start_row:=min(row_,na.rm=TRUE),by=ss_group_idcol ]
group_start_row=unique(data_DT_1col$group_start_row)
data_DT_1col[ , c("row_","group_start_row") := NULL ]
n_rows_insert=sort(c(n_rows_insert,group_start_row))
if (length(n_rows_insert)==0) return(data_DT_1col)
if (length(n_rows_insert)==1) if (n_rows_insert==1) return(data_DT_1col)
ss_columns=unique(ss_columns)
ii_pom=match(ss_columns,names(data_DT_1col) )
ii_pom=sort(ii_pom)
ss_columns=names(data_DT_1col)[ii_pom]
if (k_print) print("   Inserting rows into data ... ")
jj=2
data_out=data_DT_1col[ 1:(n_rows_insert[jj]-1),]
ii_last=NA
a_stan=""
for (jj in (2:length(n_rows_insert)) ){
dt_pom=data_DT_1col[ n_rows_insert[jj]-1,dt ]
n_pom=n_fill_number[n_rows_insert[jj]]-1
if (is.na(n_pom)){
n_pom=0
a_stan=""}
ii_previous=ii_last
a_stan_previous=a_stan
if (jj==length(n_rows_insert)){
ii_last=(n_rows_insert[jj]):(nrow(data_DT_1col))}else{
ii_last=(n_rows_insert[jj]):(n_rows_insert[jj+1]-1 )}
a_stan=as.character( data_DT_1col[ ii_last[1] , c(col_id,"x_Suffix") , with=FALSE ] )
a_stan_orig=as.character(ID_ORIG[ii_last[1]] )
if ((n_pom<hranice_dej_missval) | (hranice_dej_missval<=0) | (is.na(hranice_dej_missval)) ){
data_info_DT_1=data_DT_1col[ rep(n_rows_insert[jj]-1,n_pom ),ss_columns,with=FALSE]
data_info_DT_1[,dt:=dt_pom+(1:(n_pom)) ]
data_info_DT_1[ , YEAR :=as.numeric( format(dt, "%Y") ) ]
data_info_DT_1[ , MONTH:=as.numeric( format(dt, "%m") ) ]
data_info_DT_1[ , DAY  :=as.numeric( format(dt, "%d") ) ]
if (k_daily==FALSE){
data_info_DT_1=data_info_DT_1[ DAY==1,]}
if (k_print & n_pom>0) print_my("    ( ", jj," / ",length(n_rows_insert) ," ), (",a_stan,"),   No of inserted NA rows: ", nrow(data_info_DT_1) )
l=list(data_out,data_info_DT_1,data_DT_1col[ ii_last,] )
data_out=rbindlist(l,fill=TRUE)}else{
n_col=length(col_id)
if (all(a_stan==a_stan_orig)){
ss1="1"
ss2="2"
a_stan1=c(a_stan[1:n_col],ss1 )
a_stan2=c(a_stan[1:n_col],ss2 )}else{
ss1=a_stan[n_col+1]
ss2=as.character(as.numeric(ss1)+1)
a_stan1=c(a_stan[1:n_col],ss1 )
a_stan2=c(a_stan_orig[1:n_col],ss2 )}
if (k_print) print_my("    ( ", jj," / ",length(n_rows_insert) ," ): Splitting station  ",a_stan,"  into more parts: ", a_stan1, " and ", a_stan2)
if (any(a_stan1!=a_stan_previous)){
k_pom=(1:nrow(data_DT_1col)) %in% (1:(ii_last[1]-1) )
ss_pom1=apply(  data_DT_1col[ , c(col_id,"x_Suffix")[1:(length(a_stan_previous))] , with=FALSE] ,1,paste, collapse=ss_separator)
ss_pom2=paste(a_stan_previous,collapse=ss_separator)
k_pom2=(ss_pom1==ss_pom2 )
data_DT_1col[ k_pom & k_pom2,x_Suffix:=ss1 ]
ss_pom1=apply( data_out[ , c(col_id,"x_Suffix")[1:(length(a_stan_previous))] , with=FALSE] ,1,paste, collapse=ss_separator)
ss_pom2=paste(a_stan_previous,collapse=ss_separator)
k_pom2=(ss_pom1==ss_pom2 )
data_out[ k_pom2,x_Suffix:=ss1 ]}
k_pom=(1:nrow(data_DT_1col)) %in% (ii_last[1]:nrow(data_DT_1col))
ss_pom1=apply(  data_DT_1col[ , c(col_id,"x_Suffix")[1:(length(a_stan))] , with=FALSE] ,1,paste, collapse=ss_separator)
ss_pom2=paste(a_stan,collapse=ss_separator)
k_pom2=(ss_pom1==ss_pom2 )
data_DT_1col[ k_pom & k_pom2,x_Suffix:=ss2 ]
l=list(data_out,data_DT_1col[ ii_last,] )
data_out=rbindlist(l,fill=TRUE)
a_stan=a_stan2}}
if (k_print) print("    ... done")
rm(ID_ORIG)
if (k_leave_aux_cols==FALSE){
data_out[ , c("diff_date") := NULL ]
data_out[ , c("dt") := NULL ]}
data_out[ is.na(x_Suffix) , x_Suffix   := "" ]
if (k_daily==FALSE){
data_out[,DAY:=NULL ]}
return(data_out)}
cor_test_pval = function(x=X, y=Y , use="pairwise.complete.obs", method="pearson") {
OK <- complete.cases(x,y)
x <- x[OK]
y <- y[OK]
n <- length(x)
if (n < 3L) return(-999)
return(cor.test(x=x,y=y,use=use,method=method )$p.value )}
Check_altitudes_sel_for_neighbours=function(pole_data_vys=NA,a_vys=NA,ii_pos=nrow(pole_data_vys),missval=-999,my_probs=c(0.25,0.50,0.75) ){
pole_data_vys=pole_data_vys[ !(pole_data_vys$del_),]
pole_data_vys=pole_data_vys[ pole_data_vys$Dist_order <=ii_pos,]
if (nrow(pole_data_vys)==0) return(NA)
if (is.na(a_vys)) return(NA)
if (is.data.frame(pole_data_vys)) pole_data_vys=pole_data_vys[[1]]
qq_=quantile(pole_data_vys,probs=my_probs,type=5,na.rm=TRUE )
qq_=as.numeric(qq_)
if (a_vys>qq_[2]) qq=a_vys-qq_[3] else qq=qq_[1]-a_vys
if ((qq_[3]-qq_[1])==0 ) hodn_koef_vys=missval else hodn_koef_vys=qq/(qq_[3]-qq_[1])
if (hodn_koef_vys>1e6) hodn_koef_vys=missval
return(hodn_koef_vys)}
Check_altitude_base_neighbours=function(pole_data_vys=NA,a_vys=NA,missval=NA,my_probs=c(0.25,0.50,0.75) ){
if (is.na(a_vys)) return(NA)
if (is.data.frame(pole_data_vys)) pole_data_vys=pole_data_vys[[1]]
qq_=quantile(pole_data_vys,probs=my_probs,type=5,na.rm=TRUE )
qq_=as.numeric(qq_)
if (a_vys>qq_[2]) qq=a_vys-qq_[3] else qq=qq_[1]-a_vys
if ((qq_[3]-qq_[1])==0 ) hodn_koef_vys=missval else hodn_koef_vys=qq/(qq_[3]-qq_[1])
if (!is.na(hodn_koef_vys)) if (hodn_koef_vys>1e6) hodn_koef_vys=missval
return(hodn_koef_vys)}
Get_statistics_basic_CNT_values = function(  ss_values="" , k_append_blank=FALSE , stat_ct=NA ) {
ss_col_flag="Flag_regr"
count_val_=function(x){sum(!is.na(x))}
stat_ct_pom=NA
for (ss_flag in ss_values){
if (ss_flag=="-") next
stat_cnt=data_out_ct_sel[ Flag_regr==ss_flag,lapply(.SD,count_val_ ),by=MONTH,.SDcols=ss_col_flag ]
if (nrow(stat_cnt)==0){
stat_cnt_ct=data.table(ID=ss_col_flag )}else{
stat_cnt_ct = re_structure_DT( data_DT=stat_cnt, ss_group="MONTH", cols_to_melt=ss_col_flag , col_melted_="ID", cols_to_distribute="MONTH", col_value="VALUE2" , names_out="N" , print_output=FALSE )}
ss_text=paste(ss_flag,", CNT ",ss_col_flag,sep="")
if (ss_flag=="n") ss_text="n - no regression (to altitude)"
if (ss_flag=="o") ss_text="o - orig. vals (no standardization)"
if (ss_flag=="t") ss_text="t - orig. vals (no standardization)"
stat_cnt_ct[ , c("stat") := list( ss_text ) ]
if (! is.data.table(stat_ct_pom) ){
stat_ct_pom=stat_cnt_ct}else{
l=list(stat_ct_pom,stat_cnt_ct )
stat_ct_pom=rbindlist(l,fill=TRUE)}}
stat_ct_pom[ , c("ID_1","ID_2","BEGIN","END") := list( ID , ID , date_begin, date_end) ]
stat_ct_pom[,ID_1:=stan_base]
stat_ct_pom[ , ID_2:=""]
stat_ct_pom[ , ID:="Expected value flags"]
if (!(all(is.na(stat_ct)))){
l=list(stat_ct,as.data.table(stat_ct_pom) )
stat_ct=rbindlist(l,fill=TRUE)}else{
stat_ct=stat_ct_pom
stat_ct=Change_Column_order( DT=stat_ct, col_names=c("ID_1","ID_2","BEGIN","END","ID","stat") , order=1 )}
if (k_append_blank){
l=list(stat_ct,stat_ct[0][1,] )
stat_ct=rbindlist(l,fill=TRUE)}
return(stat_ct)}
Get_statistics_basic = function ( ss_col_base="st_base", ss_cols=col_names_stations , ss_names_ngb=ss_cols , ss_name_suffix=string_same_letters(ss_cols) , k_append_blank=FALSE, k_include_KS=FALSE, na_rm=TRUE, k_verbose=TRUE, stat_ct=NA )  {
ss_cols=ss_cols[ ss_cols %in% names(data_out_ct_sel) ]
stat_avg=data_out_ct_sel[,lapply(.SD,mean,na.rm=na_rm),by=MONTH,.SDcols=ss_cols]
stat_std=data_out_ct_sel[,lapply(.SD,sd,na.rm=na_rm),by=MONTH,.SDcols=ss_cols]
stat_length=data_out_ct_sel[,lapply(.SD,length ),by=MONTH,.SDcols=ss_cols]
count_val=function(x){sum(x*0+1,na.rm=na_rm)}
stat_cnt=data_out_ct_sel[,lapply(.SD,count_val),by=MONTH,.SDcols=ss_cols]
count_NA=function(x){sum(is.na(x))}
stat_cnt_na=data_out_ct_sel[,lapply(.SD,count_NA),by=MONTH,.SDcols=ss_cols]
if (nchar(ss_name_suffix)>0){
if ( (rev(unlist(strsplit(ss_name_suffix, split="")))[1])=="_" ) ss_name_suffix=paste("_",substr(ss_name_suffix,1,nchar(ss_name_suffix)-1), sep="")
if (substr(ss_name_suffix,1,1)!="_") ss_name_suffix=paste("_",ss_name_suffix, sep="")
ss_name_suffix=gsub("__","_", ss_name_suffix)}
stat_avg_ct = re_structure_DT( data_DT=stat_avg, ss_group="MONTH", cols_to_melt=ss_cols , col_melted_="ID", cols_to_distribute="MONTH", col_value="VALUE2",print_output=FALSE)
stat_avg_ct[ , c("stat") := list( paste("AVG",ss_name_suffix,sep="") ) ]
stat_std_ct = re_structure_DT( data_DT=stat_std, ss_group="MONTH", cols_to_melt=ss_cols , col_melted_="ID", cols_to_distribute="MONTH", col_value="VALUE2",print_output=FALSE)
stat_std_ct[ , c("stat") := list( paste("STD",ss_name_suffix,sep="") ) ]
stat_cnt_ct = re_structure_DT( data_DT=stat_cnt, ss_group="MONTH", cols_to_melt=ss_cols , col_melted_="ID", cols_to_distribute="MONTH", col_value="VALUE2",print_output=FALSE)
stat_cnt_ct[ , c("stat") := list( paste("CNT",ss_name_suffix,sep="") ) ]
l=list(stat_cnt_ct,stat_avg_ct,stat_std_ct )
stat_ct_pom=rbindlist(l,fill=TRUE)
if (length(ss_cols)>0){
if (k_include_KS){
if (k_verbose) print("      Running KS test (in Get_statistics_basic) ... ")
for (ii_ngb in (1:length(ss_cols)) ){
ii_pom2=which(ss_cols[ii_ngb]==names(data_out_ct_sel))
data_out_ct_sel[,`:=`(X=data_out_ct_sel[[ii_pom2]] ) ]
if (sum(!is.na(data_out_ct_sel$X))<=1){
if (k_verbose) print_my("     ",ss_cols[ii_ngb],": KS test not performed (not enough values available)", k_warning=TRUE)
stat_diffs_stnd_KS_ct=stat_ct_pom[0][1,]}else{
stat_std_X=data_out_ct_sel[,sd(X,na.rm=na_rm),by=MONTH ]
stat_std_X=stat_std_X[!is.na(MONTH),]
if (sum(stat_std_X[[2]]==0,na.rm=TRUE)>0 ){
if (k_verbose) print_my("     ",ss_cols[ii_ngb],": STD is zero for some months: ", stat_std_X[stat_std_X[[2]]==0,MONTH] , k_warning=TRUE)
stat_diffs_stnd_KS_ct=stat_ct_pom[0][1,]}else{
stat_diffs_stnd_KS=data_out_ct_sel[ (!is.na(MONTH)) & (!((is.na(X)))),ks.test(x=X,y=pnorm,mean=mean(X,na.rm=na_rm),sd=sd(X,na.rm=na_rm) )$p.value,by=MONTH ]
setnames(stat_diffs_stnd_KS,2,ss_cols[ii_ngb])
stat_diffs_stnd_KS_ct=re_structure_DT(stat_diffs_stnd_KS, ss_group="MONTH", cols_to_melt=ss_cols[ii_ngb] , col_melted_="ID", cols_to_distribute="MONTH", col_value="VALUE2",print_output=FALSE)}}
stat_diffs_stnd_KS_ct[ , c("stat", "ID") := list( paste("p_KS",ss_name_suffix,sep="") , ss_cols[ii_ngb] ) ]
data_out_ct_sel[, c("X"):=NULL]
l=list(stat_ct_pom,stat_diffs_stnd_KS_ct )
stat_ct_pom=rbindlist(l,fill=TRUE)}
if (k_verbose) print("     ... done (do not regard the KS warning - it is ok) ")}}
if (dim(stat_ct_pom)[1]>0){
stat_ct_pom[ , c("ID_1","ID_2","BEGIN","END") := list( ID , ID , date_begin, date_end) ]
if (nchar(ss_col_base)>1) stat_ct_pom[ ID!=ss_col_base , ID_1:="" ]
if (nchar(ss_col_base)>1) stat_ct_pom[ ID==ss_col_base , ID_2:="" ]
if (nchar(ss_col_base)>1) stat_ct_pom[ID_1==ss_col_base,ID_1:=as.character(stan_base)] else stat_ct_pom[,ID_1:=stan_base ]
for (ii_ngb in (1:length(ss_names_ngb))) stat_ct_pom[ID_2==ss_names_ngb[ii_ngb],ID_2:=stan_ngbs[ii_ngb]]
if (all(nchar(as.character(stat_ct_pom$ID_1) )==0)){
stat_ct_pom[,ID_1:=stan_base ]}}
if (!all(is.na(stat_ct_pom)))
if (!(all(is.na(stat_ct)))){
l=list(stat_ct,as.data.table(stat_ct_pom) )
stat_ct=rbindlist(l,fill=TRUE)}else{
stat_ct=stat_ct_pom
stat_ct=Change_Column_order( DT=stat_ct, col_names=c("ID_1","ID_2","BEGIN","END","ID","stat") , order=1 )}
if (k_append_blank){
l=list(stat_ct,stat_ct[0][1,] )
stat_ct=rbindlist(l,fill=TRUE)}
return(stat_ct)}
Get_statistics_covariates = function (  ss_col_base="st_base", ss_cols=col_names_ngbs , ss_name_suffix=string_same_letters(ss_cols) , k_append_blank=FALSE, stat_ct=NA ) {
stat_ct_pom=NA
ss_cols=ss_cols[ ss_cols %in% names(data_out_ct_sel) ]
if (is.empty(ss_cols)) return(stat_ct)
ii_pom=which(ss_col_base==names(data_out_ct_sel))
if (is.empty(ii_pom) ) return(stat_ct)
for (ii_ngb in (1:length(ss_cols))){
ii_pom2=which(ss_cols[ii_ngb]==names(data_out_ct_sel))
if (is.empty(ii_pom) | is.empty(ii_pom2)) next
data_out_ct_sel[,`:=`(X=data_out_ct_sel[[ii_pom2]],Y=data_out_ct_sel[[ii_pom]] ) ]
stat_cov  =data_out_ct_sel[ , cov(x=X, y=Y , use="pairwise.complete.obs", method=ss_corr_method) , by=MONTH ]
stat_cov_ct=re_structure_DT( data_DT=stat_cov, ss_group="MONTH", cols_to_melt=names(stat_cov)[2] , col_melted_="ID", cols_to_distribute="MONTH", col_value="VALUE2",print_output=FALSE)
if (length(ss_cols)==1) ss_pom="cov" else ss_pom=paste("cov_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")
if (length(ss_cols)==1) ss2=ss_cols else ss2=stan_ngbs[ii_ngb]
stat_cov_ct[ , c("ID","stat","ID_2") := list( ss_pom , paste("cov",ss_name_suffix,sep=""), ss2  ) ]
if (is.data.table(stat_ct_pom)==FALSE){
stat_ct_pom=stat_cov_ct}else{
l=list(stat_ct_pom,stat_cov_ct )
stat_ct_pom=rbindlist(l,fill=TRUE)}}
ii_pom=which(ss_col_base==names(data_out_ct_sel))
for (ii_ngb in (1:length(ss_cols)) ){
ii_pom2=which(ss_cols[ii_ngb]==names(data_out_ct_sel))
if (is.empty(ii_pom) | is.empty(ii_pom2)) next
data_out_ct_sel[,`:=`(X=data_out_ct_sel[[ii_pom2]],Y=data_out_ct_sel[[ii_pom]] ) ]
stat_cor  =data_out_ct_sel[ , cor(x=X, y=Y , use="pairwise.complete.obs", method=ss_corr_method) , by=MONTH ]
stat_cor_ct=re_structure_DT( data_DT=stat_cor, ss_group="MONTH", cols_to_melt=names(stat_cor)[2] , col_melted_="ID", cols_to_distribute="MONTH", col_value="VALUE2",print_output=FALSE)
if (length(ss_cols)==1) ss_pom="corr" else ss_pom=paste("corr_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")
if (length(ss_cols)==1) ss2=ss_cols else ss2=stan_ngbs[ii_ngb]
stat_cor_ct[ , c("ID","stat","ID_2") := list( ss_pom , paste("corr",ss_name_suffix,sep=""), ss2  ) ]
l=list(stat_ct_pom,stat_cor_ct )
stat_ct_pom=rbindlist(l,fill=TRUE)}
ii_pom=which(ss_col_base==names(data_out_ct_sel))
for (ii_ngb in (1:length(ss_cols)) ){
ii_pom2=which(ss_cols[ii_ngb]==names(data_out_ct_sel))
if (is.empty(ii_pom) | is.empty(ii_pom2)) next
data_out_ct_sel[,`:=`(X=data_out_ct_sel[[ii_pom2]],Y=data_out_ct_sel[[ii_pom]] ) ]
if ((all(is.nan(data_out_ct_sel$X))) | (all(is.nan(data_out_ct_sel$Y))) ) next
stat_cor_p=data_out_ct_sel[ , cor_test_pval(x=X, y=Y , use="pairwise.complete.obs", method=ss_corr_method) , by=MONTH ]
stat_cor_p[[2]][ stat_cor_p[[2]]==-999 ]=NA
stat_cor_p_ct=re_structure_DT(data_DT=stat_cor_p, ss_group="MONTH", cols_to_melt=names(stat_cor_p)[2] , col_melted_="ID", cols_to_distribute="MONTH", col_value="VALUE2",print_output=FALSE)
if (length(ss_cols)==1) ss_pom="p_corr" else ss_pom=paste("p_corr_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")
if (length(ss_cols)==1) ss2=ss_cols else ss2=ss2=stan_ngbs[ii_ngb]
stat_cor_p_ct[ , c("ID","stat","ID_2") := list( ss_pom , paste("p_corr_",ss_name_suffix,sep=""), ss2  ) ]
l=list(stat_ct_pom,stat_cor_p_ct )
stat_ct_pom=rbindlist(l,fill=TRUE)}
if ("X" %in% names(data_out_ct_sel)) data_out_ct_sel[, c("X","Y"):=NULL]
if (!all(is.na(stat_ct_pom))) stat_ct_pom[ , c("ID_1","BEGIN","END") := list( stan_base , date_begin, date_end ) ]
if (!all(is.na(stat_ct_pom)))
if (!(all(is.na(stat_ct)))){
l=list(stat_ct,as.data.table(stat_ct_pom) )
stat_ct=rbindlist(l,fill=TRUE)}else{
stat_ct=stat_ct_pom
stat_ct=Change_Column_order( DT=stat_ct, col_names=c("ID_1","ID_2","BEGIN","END","stat") , order=2 )
stat_ct=Change_Column_order( DT=stat_ct, col_names=c("ID") , order=1000 )}
if (k_append_blank){
l=list(stat_ct,stat_ct[0][1,] )
stat_ct=rbindlist(l,fill=TRUE)}
return(stat_ct)}
Stat_calculate_row_weighted_mean <- function(x,Y,na_rm=TRUE ){
x=as.numeric(x)
Y=as.data.table(Y)
apply(Y,1,weighted.mean,w=x,na.rm=na_rm )}
Stat_calculate_row_IQR <- function(x,Y,na_rm=TRUE,my_probs=c(0.25,0.50,0.75) ){
x=as.numeric(x[[1]])
Y=as.data.table(Y)
qq_=apply(Y,1,quantile,probs=my_probs,na.rm=na_rm,names=FALSE,type=5 )
qq_=data.frame(t(qq_))
names(qq_)=c("q025","q050","q075")
qq=qq_$q025-x
k_pom=(x > qq_$q050)
k_pom[is.na(k_pom)]=FALSE
qq[ k_pom ]=x[k_pom] - qq_$q075[k_pom]
hodn_koef_vys=(qq / (qq_$q075 - qq_$q025) )
k_pom=((qq_$q075 - qq_$q025)==0 )
hodn_koef_vys[k_pom]=NA
hodn_koef_vys[hodn_koef_vys>1e6]=NA
return(hodn_koef_vys)}
Stat_calculate_row_lm <- function(x,Y ){
Y=as.data.table(Y)
ii_c=grep( "character",  lapply(Y, class) )
if (length(ii_c)>0) Y=Y[,-ii_c]
m1=mean(x,na.rm=TRUE)
m2=apply(Y,1,mean,na.rm=TRUE )
s1=sd(x,na.rm=TRUE)
s2=apply(Y,1,sd,na.rm=TRUE )
s12=apply(Y,1,cov,y=values_altitudes)
b1=s12/(s1*s1)
b0=m2-(b1*m1)
Y_estim=data.table(sapply(x,function(x) b0+(b1*x)) )
if ((dim(Y_estim)[2]==1) & (dim(Y_estim)[1]>1) ) Y_estim=as.data.table(t(Y_estim) )
setnames(Y_estim,names(Y_estim),names(Y))
rss=apply(((Y-Y_estim)^2),1,sum,na.rm=TRUE )
np=apply(!is.na(Y),1,sum)
rss=rss/(np-1-1)
sT2=apply(((Y-m2)^2),1,sum,na.rm=TRUE )
sT2=sT2/(np)
sR2=apply(((Y_estim-m2)^2),1,sum,na.rm=TRUE )
sR2=sR2/(np)
coef_det=sR2/sT2
coef_det[sT2==0]=NA
p_val = apply( Y , 1, cor_test_pval, y=x , use="pairwise.complete.obs", method=ss_corr_method)
corr = apply( Y , 1, cor, y=x , use="pairwise.complete.obs", method=ss_corr_method)
return(list(regr_b1=b1,regr_brs=rss,regr_deter=coef_det,regr_pval=p_val,regr_cor=corr ) )}
Get_values_changes <- function(x,limit_value=0,n_min_consecutive_vals=1,k_eq_value=1,k_mt_value=0,k_lt_value=0,start_NA=FALSE){
if (is.data.table(x)) x=x[[1]]
val_=rep(0,length(x))
if (k_eq_value==1) val_[x==limit_value]=1 else val_[x==limit_value]=NA
if (k_mt_value==1) val_[x>limit_value]=1 else val_[x>limit_value]=NA
if (k_lt_value==1) val_[x<limit_value]=1 else val_[x<limit_value]=NA
val_diff=my_diff_zmena(val_,val_0=0,val_last=-1)
ii_zac=which(val_diff==1)
ii_kon=which(val_diff==-1)
ii_delka=ii_kon-ii_zac
len=rep(0,length(x))
ii_order=rep(0,length(x))
if (start_NA==TRUE) ii_shift=1 else ii_shift=0
ii_pom2=0
for (ii_pom in seq_along(ii_delka)){
len[(ii_zac[ii_pom]-ii_shift):(ii_kon[ii_pom]-1)]=ii_delka[ii_pom]+ii_shift
ii_order[(ii_zac[ii_pom]-ii_shift):(ii_kon[ii_pom]-1)]=ii_pom
if (n_min_consecutive_vals>0){
if ((ii_delka[ii_pom]+ii_shift)<n_min_consecutive_vals){
ii_order[(ii_zac[ii_pom]-ii_shift):(ii_kon[ii_pom]-1)]=-ii_pom}else{
ii_pom2=ii_pom2+1
ii_order[(ii_zac[ii_pom]-ii_shift):(ii_kon[ii_pom]-1)]=ii_pom2}}}
if (n_min_consecutive_vals>0){
ii_order[ ii_order>0 & len<n_min_consecutive_vals ]=0
val_[ len<n_min_consecutive_vals ]=0
len[ len<n_min_consecutive_vals ]=0}
return(data.frame(len=len,order=ii_order) )}
Check_values_changes <- function(x,vals_change_in,n_min_consecutive_vals=0,n_min_consecutive_vals_0=NA,k_print=TRUE,k_add_stats=FALSE ){
if (!is.data.table(vals_change_in)) vals_change_in=as.data.table(vals_change_in)
vals_change=copy(vals_change_in)
if (!is.na(n_min_consecutive_vals_0))
if (n_min_consecutive_vals_0<=n_min_consecutive_vals) n_min_consecutive_vals_0=NA
if (is.data.table(x)) x=x[[1]]
if (length(x)!=nrow(vals_change)) return(NA)
if (ncol(vals_change)!=2) return(NA)
x_=cbind(x,vals_change)
if (k_add_stats==TRUE){
vals_change[,avg:=0 ]
vals_change[,min:=0 ]
vals_change[,max:=0 ]
vals_change[,avg:=NA ]
vals_change[,min:=NA ]
vals_change[,max:=NA ]}
n_order=max(x_[[3]],na.rm=TRUE)
if (n_order>0)
for (n_ii in 1:n_order){
k_pom=(x_[[3]]==n_ii )
xx=x_[ k_pom,1]
if (max(x_[ k_pom,2],na.rm=TRUE)>0){
if (nrow(xx ) < n_min_consecutive_vals ){
if (k_print) print_my("  ... info about consecutive values deleted (event order: ",n_ii,", row: ",min(which(k_pom)),"): value ",r_min," occures only  ", nrow(xx),"  times (limit: ",n_min_consecutive_vals,")")
vals_change[k_pom,1]=0}else{
if (!is.na(n_min_consecutive_vals_0)){
if (all(xx==0))
if (nrow(xx)<n_min_consecutive_vals_0){
if (k_print) print_my("  ... info about consecutive values deleted (event order: ",n_ii,", row: ",min(which(k_pom)),"):  occurence of Zeros: ", nrow(xx),"  times (limit: ",n_min_consecutive_vals_0,")")
vals_change[k_pom,1]=0}}}
if (k_add_stats==TRUE){
a1=mean(xx[[1]],na.rm=TRUE)
vals_change[ k_pom,avg:=a1 ]
vals_change[ k_pom,min:=min(xx[[1]],na.rm=TRUE) ]
vals_change[ k_pom,max:=max(xx[[1]],na.rm=TRUE) ]}}}
return(vals_change )}
addDATE <- function(DF){
DF$DATE <- as.Date(paste(DF$YEAR,DF$MONTH,DF$DAY,sep="-"));
return(DF);}
getChars2 <- function(DT1,DT2,info=NULL,
valCol=c("VALUE2","VALUE","VAL"),
idCol=c("ID","ID_1","ID_2"),
chars="all", periods="all", dataName=NA ,
k_verbose=TRUE ){
DT1 <- as.data.table(DT1)
DT2 <- as.data.table(DT2)
if (!is.null(info)){
if (!any(c("ID_1","ID_2") %in% colnames(info))) {
stop("The info file has to contain columns ID_1 and ID_2.")}
id_1 <- info$ID_1
id_2 <- info$ID_2
id_format1 <- findID(id_1,DT1)
id_format2 <- findID(id_2,DT2)
if (length(id_format1)==0){
stop("The form of ID in the \"data file 1\" is not clear.")}else{
if (k_verbose) print_my("      ","The form of ID in the \"data file 1\" is ID_1=",paste(id_format1,collapse=""),".")
DT1$ID_1 <- apply(DT1[,id_format1,with=F],1,paste,collapse="_")}
if (length(id_format2)==0){
stop("The form of ID in the \"data file 2\" is not clear.")}else{
if (k_verbose) print_my("      ","The form of ID in the \"data file 2\" is ID_2=",paste(id_format2,collapse=""),".")
DT2$ID_2 <- apply(DT2[,id_format2,with=F],1,paste,collapse="_")}}else{
ic <- idCol[idCol %in% names(DT1)]
if (length(ic)==0){
stop("No ID column was found in the \"data file 1\".")}else{
DT1$ID_1 <- DT1[[ic[1]]]
if (k_verbose) print_my("      ","The ID-column used in the \"data file 1\" is ID_1 = ",ic[1]," .")}
ic <- idCol[idCol %in% names(DT2)]
if (length(ic)==0){
stop("No ID column was found in the \"data file 2\".")}else{
DT2$ID_2 <- DT2[[ic[1]]]
if (k_verbose) print_my("      ","The ID-column used in the \"data file 2\" is ID_2 = ",ic[1]," .")}
ids <- unique(intersect(DT1$ID_1,DT2$ID_2))
if (length(ids)==0){
stop("No common values of ID_1 and I_D2 found in the data.")}else{
info <- data.table(ID_1=ids,ID_2=ids)}}
if (!("BEGIN" %in% colnames(info))) {
info$BEGIN <- NA}
if (!("END" %in% colnames(info))) {
info$END <- NA}
dtKey <- c("YEAR","MONTH","DAY","TIME","HOUR")
dtKey <- dtKey[dtKey %in% colnames(DT1) & dtKey %in% colnames(DT2)]
if (("TIME" %in% dtKey) & ("HOUR" %in% dtKey)) {
dtKey <- dtKey["HOUR" != dtKey]}
DT1 <- setkeyv(DT1,c("ID_1",dtKey))
DT2 <- setkeyv(DT2,c("ID_2",dtKey))
vc1 <- valCol[valCol %in% colnames(DT1)]
vc2 <- valCol[valCol %in% colnames(DT2)]
if (length(vc1)==0){
stop("No column with data-values was found in the \"data file 1\".")}else{
valCol1 <- vc1[1]
if (k_verbose) print_my("      ","Used value-column in the \"data file 1\": ",valCol1)
DT1$VAL1 <- DT1[[valCol1]]}
DT1 <- DT1[!is.na(VAL1)]
if (length(vc2)==0){
stop("No column with data-values was found in the \"data file 2\".")}else{
valCol2 <- vc2[1]
if (k_verbose) print_my("      ","Used value-column in the \"data file 2\": ",valCol2)
DT2$VAL2 <- DT2[[valCol2]]}
DT2 <- DT2[!is.na(VAL2)]
if ((length(periods) == 1) && (periods == "all")) {
periods <- list()
periods$K1 <- 1
periods$K2 <- 2
periods$K3 <- 3
periods$K4 <- 4
periods$K5 <- 5
periods$K6 <- 6
periods$K7 <- 7
periods$K8 <- 8
periods$K9 <- 9
periods$K10 <- 10
periods$K11 <- 11
periods$K12 <- 12
periods$K_YEAR <- 1:12
periods$K_DJF <- c(12,1,2)
periods$K_MAM <- 3:5
periods$K_JJA <- 6:8
periods$K_SON <- 9:11}
if ((length(chars) == 1) && (chars == "all")) {
chars <- c("Begin",
"End",
"Spearman rank correlation",
"p-value of Sp. rank correlation",
"p-value of regression",
"b (regression parameter)",
"Min. difference",
"Max. difference",
"Bias (mean)",
"Bias (median)",
"MAE (mean absolute error)",
"RMSE (root mean squared error)",
"NRMSE (normalized RMSE by the range of observed values)",
"SD of differences")}
chars <- toupper(chars)
CH <- data.frame(DATA=NA_character_,REMARK=NA_character_,BEGIN=as.Date("2015-01-01"),END=as.Date("2015-01-01"))
CH$ID_1 <- NA
CH$ID_2 <- NA
CH[,names(periods)] <- NA
CH <- CH[,unique(c("ID_1","ID_2",names(CH)))]
CH0 <- CH
CH <- CH[F,]
n <- nrow(info)
i <- 1
for (i in 1:n){
id1 <- info$ID_1[i]
id2 <- info$ID_2[i]
if (k_verbose) print_my("      ","Processing ID_1: ",id1," + ID_2: ",id2,"(",i,"/",n,")")
DT1i <- DT1[ID_1==id1,c("ID_1",dtKey,"VAL1"),with=F]
DT2i <- DT2[ID_2==id2,c("ID_2",dtKey,"VAL2"),with=F]
DTi <- merge(DT1i,DT2i,by=dtKey)
DTi <- DTi[!is.na(VAL1) & !is.na(VAL2)]
if (nrow(DTi)==0){
next}
date_begin <- as.Date(info$BEGIN[i])
date_end <- as.Date(info$END[i])
if (!("DAY" %in% colnames(DT1))) {
DTi$DAY <- 1}
DTi <- addDATE(DTi)
setnames(DTi,"DATE","DATE1")
if (!is.na(date_begin)){
DTi <- DTi[DATE1>=date_begin]}
if (!("DAY" %in% colnames(DT1))) {
DTi$DAY <- 28
DTi$DAY <- number_of_days_in_a_month(DTi$YEAR,DTi$MONTH)}
DTi <- addDATE(DTi)
setnames(DTi,"DATE","DATE2")
if (!is.na(date_end)){
DTi <- DTi[DATE2<=date_end]}
if (nrow(DTi)>0){
for (j in 1:length(chars)){
char <- chars[j]
CHij <- CH0
CHij$REMARK <- tolower(char)
CHij$BEGIN <- min(DTi$DATE1)
CHij$END <- max(DTi$DATE2)
CHij$ID_1 <- id1
CHij$ID_2 <- id2
for (ii in 1:length(periods)){
months <- periods[[ii]]
name <- names(periods)[ii]
DTii <- DTi[MONTH %in% months]
vals1 <- DTii$VAL1
vals2 <- DTii$VAL2
diff <- vals1-vals2
if ((nrow(DTii)>1)&
(sd(vals1)>0)&(sd(vals2)>0) ){
if (char == "BEGIN") {
CHij[,name] <- as.numeric(min(DTii$DATE1-CHij$BEGIN))}
if (char == "END") {
CHij[,name] <- as.numeric(CHij$END-max(DTii$DATE2))}
if (char == toupper("Spearman rank correlation")) {
CHij[,name] <- round(cor(vals1,vals2, method="spearman"),digits=3)}
if (char == toupper("p-value of Sp. rank correlation")) {
options(warn=-1)
CHij[,name] <- round(cor.test(vals1,vals2,method="spearman")$p.value,digits=3)
options(warn=0)}
if (char == toupper("p-value of regression")) {
fit <- lm(vals2~vals1)
CHij[,name] <- round(summary(fit)$coefficients[2,4],digits=3)}
if (char == toupper("b (regression parameter)")) {
fit <- lm(vals2~vals1)
CHij[,name] <- round(summary(fit)$coefficients[2,1],digits=3)}
if (char == toupper("Min. difference")) {
CHij[,name] <- round(min(diff),digits=3)}
if (char == toupper("Max. difference")) {
CHij[,name] <- round(max(diff),digits=3)}
if (char == toupper("Bias (mean)")) {
CHij[,name] <- round(mean(diff),digits=3)}
if (char == toupper("Bias (median)")) {
CHij[,name] <- round(median(diff),digits=3)}
if (char == toupper("MAE (mean absolute error)")) {
CHij[,name] <- round(mean(abs(diff)),digits=3)}
if (char == toupper("RMSE (root mean squared error)")) {
CHij[,name] <- round(sqrt(mean(diff^2)),digits=3)}
if (char == toupper("NRMSE (normalized RMSE by the range of observed values)")) {
CHij[,name] <- round(sqrt(mean(diff^2))/diff(range(vals2)),digits=3)}
if (char == toupper("SD of differences")) {
CHij[,name] <- round(sd(diff),digits=3)}}else{
CHij[,name] <- NA}}
CH <- rbind(CH,CHij)}}
CH[CH$ID_1==id1 & CH$ID_2==id2,"BEGIN"] <- min(DTi$DATE1)
CH[CH$ID_1==id1 & CH$ID_2==id2,"END"] <- max(DTi$DATE2)}
if ((!is.na(dataName))&(nrow(CH)>0)){
CH$DATA <- dataName}else{
CH[,"DATA"] <- NULL}
return(CH)}
plot_QC = function( data , cols_data=NA, ss_cases_legend="" , ii_X_desctiption="", ii_problem=NA , n_type=1 , ss_lwd=NA, ss_title="" , k_not_big_circle=NA , ii_circle=NA , line_horizontal=NA ) {
cols_ii_to_plot=match(cols_data,names(data))
cols_ii_to_plot=cols_ii_to_plot[!is.na(cols_ii_to_plot)]
k_layout=FALSE
nn_poc=length(cols_ii_to_plot)
nn_col=nn_poc
if (nn_col>=2){
# cc=colorRampPalette(c("#00007F", "blue", "#007FFF", "cyan", "#7FFF7F", "yellow", "#FF7F00", "red", "#7F0000"))(nn_col) ; palette(cc)
if (n_type==1){
cc=c( rep("mediumorchid1",1),  colorRampPalette(c("green", "blue", "red"))(nn_col-1)  ); palette(cc)}else{
cc=c(  colorRampPalette(c("green", "blue", "red"))(nn_col)  ); palette(cc)}}
if (n_type==1) ss_lty=c(1,rep(2,nn_poc-1)) else ss_lty=(1:nn_poc)
if (all(is.na(ss_lwd))){
if (n_type==1) ss_lwd=c(5,rep(2,nn_poc-1)) else ss_lwd=c(rep(2,nn_poc))}else{}
if (all(is.na(cols_ii_to_plot))){
plot(0, xaxt="n")
if (nchar(ss_title)>0) try( mtext( ss_title ,side=3, line=0.5, font=4, cex=0.7, col="blue" )  ,TRUE)
print_my(ss_title," ... no data to plot")
return(-1)}
if (all(is.na(data[,cols_ii_to_plot,with=FALSE]) | is.infinite(as.matrix(data[,cols_ii_to_plot,with=FALSE])))==FALSE ){
matplot( data[,cols_ii_to_plot,with=FALSE], col=1:(nn_poc), lty=ss_lty, lwd=ss_lwd, xlab="", ylab="" , las=1, type="l", xaxt="n")} else { print("No data available")  }
if (all(is.na(data[,cols_ii_to_plot,with=FALSE]),na.rm=FALSE)==FALSE){
try(grid(col=grey(.80)),TRUE)
if (nchar(ss_title)>0) try( mtext( ss_title ,side=3, line=0.5, font=4, cex=0.7, col="blue" )  ,TRUE)}else{
print(paste("No data available"))}
n_points=1:length(ii_problem)
n_points[ii_problem==0]=NA
abline(v=n_points,col=grey(.900),lty=1,lwd=8 )
if (!(is.na(line_horizontal))) abline(h=line_horizontal,col=grey(0.75),lty=1,lwd=1 )
if (all(is.na(data[,cols_ii_to_plot,with=FALSE]),na.rm=FALSE)==FALSE){
if (length(ss_cases_legend)!=nn_poc) ss_cases_legend=names(data[,cols_ii_to_plot,with=FALSE])
if ((k_layout==F)||(ii_m==1)){
try( legend( x="topleft",inset=0 , ss_cases_legend, col=1:(nn_poc), lty=ss_lty, lwd=ss_lwd, ncol= trunc(log(length(ss_cases_legend),base=2)) , cex=0.75 , bty="n",  horiz=FALSE  )   ,TRUE)}} else { print(paste("No data available"))  }
if (length(axTicks(1))==length(ii_X_desctiption[ axTicks(1) ]) ){
try( axis(1, at=(axTicks(1)) , labels= (format(ii_X_desctiption , "%y-%m-%d"))[ axTicks(1) ],  las=2)  ,TRUE)}else{
if (axTicks(1)[1]==0){
try( axis(1, at=(axTicks(1)[-1]) , labels= (format(ii_X_desctiption , "%y-%m-%d"))[ axTicks(1)[-1] ],  las=2)  ,TRUE)}else{
stop("stop: problems with axis ...")
print("Axis could not be ploted")}}
if (n_type==1){
n_points=data[,cols_ii_to_plot[1],with=FALSE]
n_points[ii_problem==0,]=NA
if (all(is.na(ii_circle))) ii_circle=rep(2.5,length(n_points) )
ii_circle[is.na(ii_circle)]=0
k_not_big_circle[is.na(k_not_big_circle)]=FALSE
if (any(k_not_big_circle)){
points(n_points, y = NULL, type = "p", pch = 0, col="red3", lwd=2, cex=1.5 )}else{
points(n_points, y = NULL, type = "p", pch = 1, col="red3", lwd=1.5, cex=ii_circle )}}
matlines( data[,cols_ii_to_plot,with=FALSE], col=1:(nn_poc), lty=ss_lty, lwd=ss_lwd, xlab="", ylab="" , las=1, type="l", xaxt="n")
palette("default")}
Make_plots_QC=function(data_out_ct_sel,k_deleted_12,file_pdf,stan_base,ii_cand,stan_ngbs,col_names_ngbs_alt,ss_text_base_ord,k_verbose=TRUE ){
data_DT_1col_dt=ISOdatetime( year=as.numeric(data_out_ct_sel$YEAR), month = as.numeric(data_out_ct_sel$MONTH), day = data_out_ct_sel$DAY, hour = 0, min = 0, sec = 0, tz="GMT")
diff_time=difftime( data_DT_1col_dt[2:(length(data_DT_1col_dt))],data_DT_1col_dt[1:(length(data_DT_1col_dt)-1)] ,  units = "days")
diff_time=c(1, (as.numeric(diff_time, units = "days")) )
diff_time[k_deleted_12==TRUE]=0
d_diff_time=as.data.table(Get_values_changes(x=diff_time,
n_min_consecutive_vals=1,k_eq_value=1,limit_value=1,k_mt_value=1,start_NA=TRUE ) )
d_diff_time[,row:=(1:nrow(data_out_ct_sel) ) ]
d_diff_time[,period:=len ]
for (ii_pom_ in (which(d_diff_time$len>0))){
ii_zac=(ii_pom_-n_days_around)
if (ii_zac<1) ii_zac=1
ii_kon=(ii_pom_+n_days_around)
if (ii_kon>nrow(d_diff_time) ) ii_kon=nrow(d_diff_time)
d_diff_time[ (ii_zac:ii_kon),period:=1]}
d_diff_period=as.data.table(Get_values_changes(x=d_diff_time$period,
n_min_consecutive_vals=1,k_eq_value=1,limit_value=1,k_mt_value=1,start_NA=TRUE ) )
d_diff_period[ order==0,order:=NA ]
d_diff_time[ , c("per_len","per_order"):=list( d_diff_period$len , d_diff_period$order ) ]
pdf(file=file_pdf,width=12,height=8)
ss_layout=matrix(c(1:4),2,2,byrow=TRUE)
poc_layout=layout(ss_layout);
par(cex=0.8,cex.axis=0.8,mar=c(4,3,2,1) )
data_out_ct_sel[,n_problems :=d_diff_time$len ]
data_out_ct_sel[,n_periods :=d_diff_time$per_order ]
n_periods=d_diff_time$per_order
n_problems=d_diff_time$len
X_desctiption=data_DT_1col_dt
if (k_verbose) print_my("Plotting periods ... ")
for (ii_period in unique(n_periods)){
if (is.na(ii_period)) next
if (ii_period<=0) next
k_pom_periods=(ii_period==n_periods)
k_pom_periods[is.na(k_pom_periods)]=FALSE
ss_text_out=paste(stan_base,"-ord",
gsub(' ','0',paste(format(ii_cand, justify="right", width=floor(log10( length((unique(ngb_info_DT$id_ord))) ))+1))),     "-per",
gsub(' ','0',paste(format(ii_period, justify="right", width=floor(log10( length(n_periods) ))+1))),
sep="")
stan_ngbs_weights_stnd=c(4,standardize_to_limits(X=stan_ngbs_weights,r_min=1,r_max=3 ) )
if (k_verbose) print_my(" Plotting ",ss_text_out)
if (dim(data_out_ct_sel[ k_pom_periods,])[1] < 2 ){
if (k_verbose) print_my("Problem: one or no value to plot, ",ss_text_out, ", ... skipping the plot", k_warning=TRUE)
next}
cols_data = c("st_base_",col_names_ngbs_alt)
plot_QC( data=data_out_ct_sel[ k_pom_periods , ] , cols_data=cols_data , ss_cases_legend=c(stan_base,stan_ngbs) , ii_X_desctiption=X_desctiption[ k_pom_periods ]  , ii_problem=n_problems[ k_pom_periods ] , n_type=1 , ss_lwd=stan_ngbs_weights_stnd , ss_title=paste(ss_text_base_ord,": ","Base and Ngbs standardized to Altitude", sep="") , k_not_big_circle=data_out_ct_sel[ k_pom_periods , (Same_base + Same_ngbs)>=10 ] , ii_circle=data_out_ct_sel[ k_pom_periods , QC_result ] )
cols_data=c(col_names_diffs_stnd)
plot_QC( data=data_out_ct_sel[ k_pom_periods , ] , cols_data=cols_data , ss_cases_legend= paste(stan_ngbs,stan_base,sep="-") , ii_X_desctiption=X_desctiption[ k_pom_periods ]  , ii_problem=n_problems[ k_pom_periods ] , n_type=0 , ss_lwd=stan_ngbs_weights_stnd[-1],  ss_title=paste(ss_text_base_ord,": ","Standardized differences of Ngbs to Base", sep="") , line_horizontal=0 )
cols_data = c("t1_base",col_names_ngbs_t1)
plot_QC( data=data_out_ct_sel[ k_pom_periods , ], cols_data=cols_data , ss_cases_legend=c(stan_base,stan_ngbs) , ii_X_desctiption=X_desctiption[ k_pom_periods ]  , ii_problem=n_problems[ k_pom_periods ] , n_type=1, ss_lwd=stan_ngbs_weights_stnd,  ss_title=paste(ss_text_base_ord,": ","First differences Base and Ngbs", sep="") , k_not_big_circle=data_out_ct_sel[ k_pom_periods , (Same_base + Same_ngbs)>=10 ] , ii_circle=data_out_ct_sel[ k_pom_periods , QC_result ] , line_horizontal=0 )
cols_data = c("Perct_Exc","Perc_t1_Exc","CDF_med_d" ,"CDF_b_sMed" , "Coef_IQR","IQR_time", "QC_result")
plot_QC( data=data_out_ct_sel[ k_pom_periods , ] , cols_data=cols_data , ss_cases_legend=cols_data  , ii_X_desctiption=X_desctiption[ k_pom_periods ]  , ii_problem=n_problems[ k_pom_periods ] , n_type=0 , ss_title=paste(ss_text_out,": ","Various statistics", sep="") , line_horizontal=max_QC_result )}
if (k_plot==TRUE){
if (k_verbose) print_my(" ... plot saved to: ",file_pdf)
if ((plotkind!="pdf")) {}else{
dev.off()}}}
