ShowCodePageInfo=function(nCP=0){
cCP=NA
if (nCP==0) cCP=NA
if (nCP==1) cCP=437
if (nCP==2) cCP=850
if (nCP==3) cCP=1252
if (nCP==4) cCP=10000
if (nCP==100) cCP=852
if (nCP==101) cCP=866
if (nCP==102) cCP=865
if (nCP==103) cCP=861
if (nCP==104) cCP=895
if (nCP==105) cCP=620
if (nCP==106) cCP=737
if (nCP==107) cCP=857
if (nCP==120) cCP=950
if (nCP==121) cCP=949
if (nCP==122) cCP=936
if (nCP==123) cCP=932
if (nCP==124) cCP=874
if (nCP==125) cCP=1255
if (nCP==126) cCP=1256
if (nCP==150) cCP=10007
if (nCP==151) cCP=10029
if (nCP==152) cCP=10006
if (nCP==200) cCP=1250
if (nCP==201) cCP=1251
if (nCP==202) cCP=1254
if (nCP==203) cCP=1253
return(cCP)}
Get_codepage=function(my_file){
if (file.exists(my_file)){
bytes_cp=as.integer(readBin(my_file, "raw", n=31+1))
n29=(bytes_cp[29+1])
cp_local=as.character(ShowCodePageInfo(n29))
return(cp_local)}else{
return(NA)}}
my__read_dbf <- function(my_file, remove.x=T, delete=F, read_MFD=T, mfd_name="MFD" , k_del_NA=T , k_convert_codepage=F , print_output=TRUE ) {
if (!(file.exists(my_file))) return(NA)
library(foreign)
add_MFD <- read_MFD
if (delete & !read_MFD){
read_MFD <- T}
{
as.is=T
if ((any(ls()=="df"))) rm(df)
if ((any(ls()=="DF"))) rm(df)
df <- try(invisible(.Call(foreign:::Rdbfread,as.character(path.expand(my_file))) ),FALSE)
if (class(df)== "try-error") {
print_my( 'error in my__read_dbf.r, file ',my_file) ;}
data_types <- attr(df, "data_types")
if (k_convert_codepage){
cp_local=Get_codepage(my_file)
if (!all(is.na(cp_local))){
for (ii_pom in (which(data_types=="C")) ) df[[ii_pom]]=iconv( df[[ii_pom]] , from=cp_local, to="UTF-8")
if (print_output==TRUE) print(paste("Read string values (",basename(my_file),") converted from ",cp_local," to UTF-8 (my__read_dbf.R)", sep=""))}}
onames <- names(df)
if (remove.x){
onames <- names(df)
ii_d= which(onames=="")
if (length(ii_d)>0){
if (print_output==TRUE)
print_my(" Reading dbf (my__read_dbf.R): ","'' named columns removed (",length(ii_d)," cols) ")
df=df[,-(ii_d )]
data_types=data_types[-(ii_d )]}
onames <- names(df)
ii_d= which(onames=="\r")
if (length(ii_d)>0){
if (print_output==TRUE)
print_my(" Reading dbf (my__read_dbf.R): ","'\r' named columns removed (",length(ii_d)," cols), names: ",names(df)[ii_d])
df=df[,-(ii_d )]
data_types=data_types[-(ii_d )]}
onames <- names(df)
ii_d= which(toupper(onames)==toupper("_NullFlags"))
if (length(ii_d)>0){
if (print_output==TRUE)
print_my(" Reading dbf (my__read_dbf.R): ","'_NullFlags' named column removed")
df=df[,-(ii_d )]
data_types=data_types[-(ii_d )]}}
onames <- names(df)
for (i in seq_along(onames)) if (data_types[i] == "D") { df[[i]] <- as.Date(df[[i]], format = "%Y%m%d") }
if (!as.is){
df <- data.frame(lapply(df,function(x) if (is.character(x))
factor(x)
else x))
attr(df, "data_types") <- data_types}
DF=df}
if (read_MFD){
bytes2int <- function(bytes){
return(sum(bytes*(256^(0:(length(bytes)-1)))));}
bytes <- as.integer(readBin(my_file, "raw", n=12));
n1 <- bytes2int(bytes[4:7+1]);
n2 <- bytes2int(bytes[8:9+1]);
n3 <- bytes2int(bytes[10:11+1]);
n <- n2+1+n1*n3;
if (!(bytes[1] %in% c(3,48))){
print(paste("An unknown format of the dbf file detected. ",
"If no other problem occurred, the file was probably",
" read correctly. However, it would be good to check",
" the format of the file (my__read_dbf.R).",sep=""),quote=F)}
bytes <- as.integer(readBin(my_file, "raw", n=n));
mfd <- numeric(n1);
for (i in 1:n1){
b <- bytes[n2+1+(i-1)*n3];
if (is.na(b) | is.nan(b) | is.null(b)){
stop("File format error: A necessary marked-for-deletion-flag bit is missing (my__read_dbf.R).")}
if (b==32){
mfd[i] <- 0;}else if (b==42){
mfd[i] <- 1;}else{
stop("File format error: A marked-for-deletion-flag bit contains an unexpected value (my__read_dbf.R).")}}
if (nrow(DF) !=length(mfd)){
stop("File format error: The length of the marked-for-deletion-flag vector differs
from the number of rows of data.frame read by \"read.dbf\" (my__read_dbf.R).")}
if (add_MFD){
if (mfd_name %in% colnames(DF)){
stop(paste("Column with name \"",mfd_name,"\" already exits, select a different name (my__read_dbf.R).",sep=""));}
DF[,mfd_name] <- mfd
nc <- ncol(DF)}
if (delete){
if (print_output==TRUE)
print(paste(" ", sum(mfd!=0), " rows deleted"))
DF <- DF[mfd==0,]}
if (add_MFD && sum(DF[,mfd_name]!=0)==0){
DF=DF[,-(which(mfd_name==names(DF)) )]}}
if (k_del_NA){
ii_pom=((apply(!(is.na(DF)),2,sum))==0)
if (sum(ii_pom)>0 )
if (print_output==TRUE){
print("Removing columns with NA values (my__read_dbf.R): ")
print(names(DF)[ii_pom])}
DF=DF[,(apply(!(is.na(DF)),2,sum))!=0 ]}
return(DF);}
